
OfficeWebUI = {

    // Get DOM object properties
    _gO: function(obj, coord) {
        obj = document.getElementById(obj);
        var val = obj["offset" + coord];
        while ((obj = obj.offsetParent) != null) {
            val += obj["offset" + coord];
        }
        return val;
    },

    SaveLastUrl: function ()
    {
      $.jStorage.set("LastUrl", document.location.href);
    },
    
    GetLastUrl: function ()
    {
      $.jStorage.get("LastUrl");
    }
    
};

OfficeWebUI.ClearStorage = function ()
{
  $.jStorage.flush();

  // Cookie OfficeWebUI deikenlerinden temizleniyor...
  //$.cookie('LastTab', null);
  //$.cookie('LastItem', null);
  //$.cookie('LastArea', null);
}


/* Ribbon */

// The Ribbon Namespace
OfficeWebUI.Ribbon = {

    // Get DOM object properties
    _gO: function(obj, coord) {
        obj = document.getElementById(obj);
        var val = obj["offset" + coord];
        while ((obj = obj.offsetParent) != null) {
            val += obj["offset" + coord];
        }
        return val;
    },

    // Save last tab state
    SaveLastTab: function(tabid) {
      $.jStorage.set("LastTab", tabid);

      if (PageMethods.SaveLayoutRibbonSettings != null)
        PageMethods.SaveLayoutRibbonSettings($.jStorage.get("LastArea"), $.jStorage.get("lastitem"), $.jStorage.get("LastTab"));

      // $.cookie('LastTab', tabid, { expires: 365, path:"/", domain:"/" });
    },

    // Save last Backstage Page state
    SaveLastBackstagePage: function(pageId) {
        if (typeof OfficeWebUI_Ribbon_LastBackstagePage != "undefined")
            document.getElementById(OfficeWebUI_Ribbon_LastBackstagePage).value = pageId;
    },

    // Get last Backstage page
    GetLastBackstagePage: function() {
        if (typeof OfficeWebUI_Ribbon_LastBackstagePage != "undefined")
            return document.getElementById(OfficeWebUI_Ribbon_LastBackstagePage).value;
    },

    // Get last tab
    GetLastTab: function() {
        /*
        if ($.cookie('LastTab') != null)
          return $.cookie('LastTab');
        else if (typeof OfficeWebUI_Ribbon_LastTab != "undefined")
          return document.getElementById(OfficeWebUI_Ribbon_LastTab).value;
          */
        
        if ($.jStorage.get("LastTab") != null)
          return $.jStorage.get('LastTab');
        else if (typeof OfficeWebUI_Ribbon_LastTab != "undefined")
          return document.getElementById(OfficeWebUI_Ribbon_LastTab).value;
    },

    // Get associated Context for current Tab
    GetCurrentTabContext: function(tabid) {
        return $(".RibbonTab[tabid=" + OfficeWebUI.Ribbon.GetLastTab() + "]").parent().attr("ContextID");
    },

    // Hide all Tabs
    HideAllTabs: function() {
        $(".RibbonTab").removeClass("RibbonTabActive");
        $(".RibbonTabContent").css("display", "none");
    },

    // Init the Ribbon
    Init: function() {

        if (OfficeWebUI.Ribbon.GetLastTab() != "") {
            //alert(OfficeWebUI.Ribbon.GetLastTab());
            var tempid = $(".RibbonTab[tabid=" + OfficeWebUI.Ribbon.GetLastTab() + "]").attr("AssociatedTab");
            $(".RibbonTab[tabid=" + OfficeWebUI.Ribbon.GetLastTab() + "]").addClass("RibbonTabActive");
            $("div[AssociatedTab=" + tempid + "]").css("display", "block");

            OfficeWebUI.Ribbon.ShowContext(OfficeWebUI.Ribbon.GetCurrentTabContext(OfficeWebUI.Ribbon.GetLastTab()));

        } else {
            var tempid = $(".RibbonTab:first").attr("AssociatedTab");
            $(".RibbonTab:first").addClass("RibbonTabActive");
            $("div[AssociatedTab=" + tempid + "]").css("display", "block");
        }

        //if (OfficeWebUI.Ribbon.GetLastBackstagePage() != "") {
        //alert("last page = " + OfficeWebUI.Ribbon.GetLastBackstagePage());
        //}
    },

    // Show a given context
    ShowContext: function(contextId) {
        $("div[ContextID=" + contextId + "]").css("display", "block");
    },

    // Hide all contexts
    HideAllContexts: function() {
        $("div[ContextID]").css("display", "none");
        OfficeWebUI.Ribbon.HideAllTabs();
        OfficeWebUI.Ribbon.Init();
    },

    HideTab: function(tabid) {
        $("div[tabid=" + tabid + "]").hide();
    },

    // Hide a given context
    HideContext: function(contextId) {
        OfficeWebUI.Ribbon.HideAllTabs();
        OfficeWebUI.Ribbon.Init();
        $("div[ContextID=" + contextId + "]").css("display", "none");
    },

    // Show a given Tab
    ShowTab: function(tabid) {
        OfficeWebUI.Ribbon.HideBackstage();
        OfficeWebUI.Ribbon.HideAllTabs();
        $("div[tabid=" + tabid + "]").addClass("RibbonTabActive");
        $("div[TabContentID=" + tabid + "]").css("display", "block");

        OfficeWebUI.Ribbon.SaveLastTab(tabid);
    },

    ShowFirstTab: function() {
        OfficeWebUI.Ribbon.HideBackstage();
        OfficeWebUI.Ribbon.HideAllTabs();
        
        var tempid = $(".RibbonTab:first").attr("AssociatedTab");
        $(".RibbonTab:first").addClass("RibbonTabActive");
        $("div[AssociatedTab=" + tempid + "]").css("display", "block");
    },

    // Toggle Off the Ribbon
    ToggleOffRibbon: function() {
        OfficeWebUI.Ribbon.HideAllTabs();
        $(".RibbonToggleButtonUp").attr("class", "RibbonToggleButtonDown");
        $(".RibbonTabsContainer").css("display", "none");
    },

    // Toggle On the Ribbon
    ToggleOnRibbon: function(sForce) {
        $(".RibbonToggleButtonDown").attr("class", "RibbonToggleButtonUp");
        $(".RibbonTabsContainer").css("display", "block");
        if (sForce)
            OfficeWebUI.Ribbon.Init();
    },

    // Auto toggle the Ribbon
    ToggleRibbon: function() {
        if ($(".RibbonTabsContainer").css("display") == "block") {
            OfficeWebUI.Ribbon.ToggleOffRibbon();
        } else {
            OfficeWebUI.Ribbon.ToggleOnRibbon(true);
        }

        $('.RibbonTabsContainer').trigger('Toggled');
    },

    // Hide the Backstage
    HideBackstage: function() {
        $('.RibbonBackstageContainer').css("display", "none");
    },

    // Toggle Backstage 
    ToggleBackstage: function() {
        if ($('.RibbonBackstageContainer').css("display") == "none") {
            OfficeWebUI.Ribbon.HideAllTabs();
            var offset = $('.RibbonContextsContainer').offset();
            $('.RibbonBackstageContainer').height($(window).height() - 52 - offset.top);
            $('.RibbonBackstageContainer').width($(".RibbonContextsContainer").width() - 2);
            $('.RibbonBackstageContainer').css("display", "block");
            OfficeWebUI.Ribbon.InitBackstage();
        } else {
            $('.RibbonBackstageContainer').css("display", "none");
            OfficeWebUI.Ribbon.Init();
        }
    },

    HideAllBackstagePages: function() {
        $(".BackstagePageTitle").each(function(index) {
            $(this).removeClass("BackstagePageActive");
            $(this).css("background-color", "transparent");
            $(this).css("border-bottom", "1px solid transparent");
            $(this).css("border-top", "1px solid transparent");
        });

        //$(".BackstagePageTitle").removeClass("BackstagePageActive");
        //$(".BackstagePageTitle").css("background-color", "transparent");
        //$(".BackstagePageTitle").css("border-bottom", "1px solid transparent");
        //$(".BackstagePageTitle").css("border-top", "1px solid transparent");
        $(".BackstagePageContent").css("display", "none");
    },

    // Init Backstage view
    InitBackstage: function() {
        $(".BackstagePageTitle:first").click();
        /*
        var tempid = $(".BackstagePageTitle:first").attr("AssociatedPage");
        $(".BackstagePageTitle:first").addClass("BackstagePageActive");
        $("div[AssociatedPage=" + tempid + "]").css("display", "block");
        */
    },

    // Close all menus (Items with menu)
    CloseAllMenus: function() {
        $(".RibbonItemWithMenu").removeClass("RibbonMenuActive");
        $(".RibbonDropDownMenu").hide();
    },

    // Close all galleries
    CloseAllGalleries: function() {
        $(".RibbonGalleryActive").removeClass("RibbonGalleryActive");
        $(".RibbonGallerySubMenu").hide();
    },

    // Hide Application Menu
    HideMenu: function() {
        $('.RibbonApplicationMenuContainer').css("display", "none");
    },

    // Toggle Application Menu
    ToggleMenu: function() {
        $('.RibbonApplicationMenuContainer').toggle();
        /*
        if ($('.RibbonApplicationMenuContainer').css("display") == "none") {
        $('.RibbonApplicationMenuContainer').css("display", "block");
        } else {
        $('.RibbonApplicationMenuContainer').css("display", "none");
        }
        */
    },

    // Check an item
    CheckItem: function(itemId) {
        $("div[ItemID=" + itemId + "]").addClass("Checked");
    },

    // Uncheck an item
    UnCheckItem: function(itemId) {
        $("div[ItemID=" + itemId + "]").removeClass("Checked");
    },

    // Toggle checked state
    ToggleCheck: function(itemId) {
        $("div[ItemID=" + itemId + "]").toggleClass("Checked");
    },


    // Show a Gallery
    OpenGallery: function(src, trg) {
        var src1 = document.getElementById(src);
        document.getElementById(trg).style.display = (document.getElementById(trg).style.display == "none") ? "block" : "none";
        document.getElementById(trg).style.left = OfficeWebUI.Ribbon._gO(src, "Left") + "px";
        document.getElementById(trg).style.top = (OfficeWebUI.Ribbon._gO(src, "Top") + src1.offsetHeight - 1) + "px";
    },

    // Show a menu
    ShowMenu: function(src, trg) {
        document.getElementById(trg).style.display = (document.getElementById(trg).style.display == "none") ? "block" : "none";
        document.getElementById(trg).style.left = OfficeWebUI.Ribbon._gO(src.id, "Left") + "px";
        document.getElementById(trg).style.top = (OfficeWebUI.Ribbon._gO(src.id, "Top") + src.offsetHeight) + "px";
    },

    /*
    // Keep the menu opened
    KeepMenu: function(trg) {
    document.getElementById(trg).style.display = "";
    document.getElementById(trg).getAttribute("MenuOpener").className = "RibbonSmallItem_Over";
    },

    // Hide a menu
    HideMenu: function(trg) {
    document.getElementById(trg).style.display = "none";
    },

    // Register the "File Menu"
    RegisterFileMenu: function(text, container, menu, color) {
    try {
    if (color == null) {
    color = "green";
    }
    var divTag = document.createElement("div");
    divTag.id = "SBRibbon_FileMenu";
    divTag.className = "Ribbon_FileMenu_" + color; // Change this classname to customize the File Menu, See CSS file
    divTag.innerHTML = text;
    divTag.setAttribute("onclick", "SBRibbon.ShowMenu(this, '" + menu + "_FileMenu')");
    document.body.appendChild(divTag);

            var temp_bar = document.getElementById(container + "_header");
    temp_bar.insertBefore(divTag, temp_bar.firstChild);

            document.getElementById("SBRibbon_FileMenu").appendChild(document.getElementById(menu + "_FileMenu"));

        } catch (e) { alert(e); }
    },
    */
};


OfficeWebUI.Ribbon.RibbonInit = function () {


    // Click on Items with Gallery
    $(".RibbonItemWithTooltip").hover(function() {
        var tooltiptext = $(this).attr("tooltip");
        var offset = $(this).offset();
        $(".RibbonTooltipContainer").show();
        $(".RibbonTooltipContainer").css("left", offset.left);
        $(".RibbonTooltipContainer").html(tooltiptext);
    }, function() {
        $(".RibbonTooltipContainer").hide();
    });

    // Click anywhere on the page
    $(document).bind('click', function(e) {
        var $clicked = $(e.target);

        if ((!$clicked.parent().hasClass("RibbonApplicationMenuContainer"))
           && (!$clicked.hasClass("ApplicationButton"))
           ) {
            $(".RibbonApplicationMenuContainer").hide();
        }

        if (!$clicked.parents().hasClass("RibbonItemWithMenu")) {
            OfficeWebUI.Ribbon.CloseAllMenus();
        }

        if (!$clicked.parents().hasClass("RibbonGalleryDropDownArrow")) {
            OfficeWebUI.Ribbon.CloseAllGalleries();
        }

    });

    // Mouse over Backstage Pages title    
    $(".BackstagePageTitle").hover(
      function() {
          if ($(this).hasClass("BackstagePageActive")) {

          } else {
              $(this).css("background-color", OfficeWebUI_Ribbon_AppMenuColor);
              $(this).css("border-top", "1px solid " + OfficeWebUI_Ribbon_AppMenuColor);
              $(this).css("border-bottom", "1px solid " + OfficeWebUI_Ribbon_AppMenuColor);
          }
      },
      function() {
          if ($(this).hasClass("BackstagePageActive")) {
          } else {
              $(this).css("border-top", "1px solid transparent");
              $(this).css("border-bottom", "1px solid transparent");
              $(this).css("background-color", "transparent");
          }
      }
    );


    // Init Ribbon
    OfficeWebUI.Ribbon.HideAllTabs();
    OfficeWebUI.Ribbon.Init();

    // If Browser ie,
    if ((PageMethods.isIE) && (window.PIE)) {
      $(".ApplicationButton").each( function () { PIE.attach(this); } );
      //$(".RibbonTab.RibbonTabActive").each( function () { PIE.attach(this); } );
    };

    // Click on ribbon tabs
    $(".RibbonTab").click(function() {
        OfficeWebUI.Ribbon.HideBackstage();
        OfficeWebUI.Ribbon.HideAllTabs();
        OfficeWebUI.Ribbon.ToggleOnRibbon(false);
        var tempid = $(this).attr("AssociatedTab");
        var tabid = $(this).attr("tabid");
        $("div[AssociatedTab=" + tempid + "]").css("display", "block");
        $(this).addClass("RibbonTabActive");
        OfficeWebUI.Ribbon.SaveLastTab(tabid);
    });

    // Click on Backstage Pages title
    $(".BackstagePageTitle").click(function() {
        OfficeWebUI.Ribbon.HideAllBackstagePages();
        var tempid = $(this).attr("AssociatedPage");
        $("div[AssociatedPage=" + tempid + "]").css("display", "block");
        $(this).addClass("BackstagePageActive");

        $(this).css("background-color", OfficeWebUI_Ribbon_AppMenuColor);
        $(this).css("border-top", "1px solid " + OfficeWebUI_Ribbon_AppMenuColor);
        $(this).css("border-bottom", "1px solid " + OfficeWebUI_Ribbon_AppMenuColor);
        //OfficeWebUI.Ribbon.SaveLastBackstagePage(tempid);
    });

    // Click on Items with menu
    $(".RibbonItemWithMenu").click(function() {
        OfficeWebUI.Ribbon.CloseAllMenus();
        $(this).addClass("RibbonMenuActive");
        $(this).find(".RibbonDropDownMenu").show();
    });

    // Click on Items with Gallery
    $(".RibbonGalleryDropDownArrow").click(function() {
        OfficeWebUI.Ribbon.CloseAllGalleries();
        $(this).addClass("RibbonGalleryActive");
        $(this).parent().find(".RibbonGallerySubMenu").show();
        $(this).parent().find(".RibbonGallerySubMenu").css("margin-top", "65px");
    });


};


/* Ribbon CollapseGroup */



$(document).ready(function() {

//    $(window).resize(function() {
//        rtime = new Date();
//        if (timeout === false) {
//            timeout = true;
//            setTimeout(resizeend, delta);
//        }
//    });

//    $(".RibbonGroupCollapsedContainerTable").click(function() {
//        OfficeRibbonResizer_ResetLayout();
//        $(this).addClass("RibbonGroupCollapsedContainerTableActive");
//        $(this).parent().find(".RibbonGroupCollapsedContainerDropDown").show();
//    });


    // Click anywhere on the page
    $(document).bind('click', function(e) {
        var $clicked = $(e.target);

        if ((!$clicked.parents().hasClass("RibbonGroupCollapsedContainerTable")) && (!$clicked.parents().hasClass("RibbonGroupCollapsedContainerDropDown"))) {
            OfficeRibbonResizer_ResetLayout();
        }

    });


//    OfficeRibbonResizer();

});


var _TotalContainerWidth = 0;
var _TotalElementsWidth = 0;
var _ActiveTab;


var rtime = new Date(1, 1, 2000, 12, 00, 00);
var timeout = false;
var delta = 0;

function resizeend() {
    if (new Date() - rtime < delta) {
        setTimeout(resizeend, delta);
    } else {
        timeout = false;
        OfficeRibbonResizer();
    }
}


function OfficeRibbonResizer_ResetLayout() {
    $(".RibbonGroupCollapsedContainerDropDown").hide();
    $(".RibbonGroupCollapsedContainerTableActive").removeClass("RibbonGroupCollapsedContainerTableActive");
}


function OfficeRibbonResizer() {

    _TotalContainerWidth = $(".RibbonTabsContainer").width();

    $(".RibbonGroupCollapsedContainer").hide();
    $(".RibbonGroupContent").show();


    $("DIV.RibbonGroupContent").each(function(idx) {

        var _element = $(this);
        var _elementID = $(this).attr("id");

        var _AssociatedElement = $("DIV[AssociatedElement=" + _elementID + "]");
        var _DropDownContainer = _AssociatedElement.find(".RibbonGroupCollapsedContainerDropDown");

        if (_DropDownContainer.find("table").length > 0)
            _DropDownContainer.find("table").first().appendTo(_element);


    });

    
    $(".RibbonTabContent").each(function(idx) {

        if ($(this).css("display") != "none") {
            _ActiveTab = $(this);
        }

    });


    _TotalElementsWidth = 0;
    _ActiveTab.find("DIV.RibbonGroupCollapsedContainer, DIV.RibbonGroupContent").each(function(idx) {

        var _element = $(this);
        if (_element.css("display") != "none")
            _TotalElementsWidth = _TotalElementsWidth + _element.width();
    
    });

    //alert("total : " + _TotalContainerWidth);
    while (_TotalElementsWidth > (_TotalContainerWidth - 100)) {
        HideElement();
        RacalculateWidth();
        //alert("elements : " + _TotalElementsWidth);
    }
    

}

function RacalculateWidth() {

    _TotalElementsWidth = 0;
    _ActiveTab.find("DIV.RibbonGroupCollapsedContainer, DIV.RibbonGroupContent").each(function(idx) {

        var _element = $(this);
        if (_element.css("display") != "none")
            _TotalElementsWidth = _TotalElementsWidth + _element.width();
    
    });
}


function HideElement() {

    $(_ActiveTab.find(".RibbonGroupContent").get().reverse()).each(function() {

        var _element = $(this);
        if ((_element.attr("objType") == "Element") && (_element.css("display") != "none")) {

            _element.hide();

            var _elementWidth = _element.width();
            var _AssociatedElement = $("DIV[AssociatedElement=" + _element.attr("id") + "]");
            var _DropDownContainer = _AssociatedElement.find(".RibbonGroupCollapsedContainerDropDown");

            if (_element.find("table").length > 0)
                _element.find("table").first().appendTo(_DropDownContainer);

            _AssociatedElement.show();
            _AssociatedElement.find(".RibbonGroupCollapsedContainerDropDown").css("width", _elementWidth);
            _DropDownContainer.hide();
            return false;
        }
    });
}




/* WorkSpace */



OfficeWebUI.Workspace = {

    _AjaxLoadSupport: function() {
        OfficeWebUI.Workspace.Init();
        //OfficeWebUI.Workspace.ResizeLayout();
        OfficeWebUI.Workspace.RegisterAreaButtonClick();

        $(".OfficeWebUI_WorkspaceItem").click(function() {
            OfficeWebUI.Workspace.ClearAllItems();
            var tempid = $(this).attr("id");
            $(this).addClass("OfficeWebUI_WorkspaceItemActive");
            // save last item is in code-behind
        });

        //$(".OfficeWebUI_Workspace").resize(function() {
        //    OfficeWebUI.Workspace.ResizeLayout();
        //});

        //$(window).resize(function() {
        //    OfficeWebUI.Workspace.ResizeLayout();
        //});

        //$(".RibbonTabsContainer").bind("Toggled", function() { OfficeWebUI.Workspace.ResizeLayout(); });

        $(document).ready(function () {
          OfficeWebUI.Workspace.ResizeLayout();
        });
    },

    RegisterAreaButtonClick: function() {

        $(".OfficeWebUI_WorkspaceAreaButton").click(function() {
            OfficeWebUI.Workspace.HideAllAreas();
            var tempid = $(this).attr("AssociatedArea");
            var buttonid = $(this).attr("areaid");
            $("div[AssociatedArea=" + tempid + "]").show();
            $(this).addClass("WorkspaceAreaActive");
            OfficeWebUI.Workspace.SaveLastArea(buttonid);
        });

    },

    HideAllAreas: function() {
        $(".OfficeWebUI_WorkspaceAreaZone").hide();
        $(".WorkspaceAreaActive").removeClass("WorkspaceAreaActive");
    },

    ClearAllItems: function() {
      $(".OfficeWebUI_WorkspaceItemActive").removeClass("OfficeWebUI_WorkspaceItemActive");
    },

    SaveLastItem: function(itemId) {
        $.jStorage.set("lastitem", itemId);
      
        if (PageMethods.SaveLayoutRibbonSettings != null)
          PageMethods.SaveLayoutRibbonSettings($.jStorage.get("LastArea"), $.jStorage.get("lastitem"), $.jStorage.get("LastTab"));

        // Cookie'ye yazlyor...
        //$.cookie('LastItem', itemId, { expires: 365, path:"/", domain:"/" });
    },

    DeleteLastItem: function () {
      var LastItem = OfficeWebUI.Workspace.GetLastItem();

      //if (LastItem != null)
      //  $.cookie('LastItem', null);

      if (LastItem != null)
        $.jStorage.deleteKey("lastitem");

      if (PageMethods.SaveLayoutRibbonSettings != null)
        PageMethods.SaveLayoutRibbonSettings($.jStorage.get("LastArea"), null, $.jStorage.get("LastTab"));
    },

    SaveLastArea: function(areaid) {
        $.jStorage.set("LastArea", areaid);

        if (PageMethods.SaveLayoutRibbonSettings != null)
          PageMethods.SaveLayoutRibbonSettings($.jStorage.get("LastArea"), $.jStorage.get("lastitem"), $.jStorage.get("LastTab"));

        // Cookie'ye yazlyor...
        //$.cookie('LastArea', areaid, {expires: 365, path:"/", domain:"/"});
    },

    GetLastItem: function() {
        /*
        if ($.cookie('LastItem') != null)
          return $.cookie('LastItem')
        else if (typeof OfficeWebUI_Workspace_LastItem != "undefined")
          return document.getElementById(OfficeWebUI_Workspace_LastItem).value;
          */

        if ($.jStorage.get("lastitem") != null)
          return $.jStorage.get('lastitem');
        else if (typeof OfficeWebUI_Workspace_LastItem != "undefined")
          return document.getElementById(OfficeWebUI_Workspace_LastItem).value;
    },

    GetLastArea: function() {
        /*
        if ($.cookie('LastArea') != null)
          return $.cookie('LastArea');
        else if (typeof OfficeWebUI_Workspace_LastArea != "undefined")
          return document.getElementById(OfficeWebUI_Workspace_LastArea).value;
          */

        if ($.jStorage.get("LastArea") != null)
          return $.jStorage.get('LastArea');
        else if (typeof OfficeWebUI_Workspace_LastArea != "undefined")
          return document.getElementById(OfficeWebUI_Workspace_LastArea).value;
    },

    DeleteLastArea: function ()
    {
      var LastItem = OfficeWebUI.Workspace.GetLastArea();
      if (LastItem != null)
        $.jStorage.deleteKey("LastArea");
        //$.cookie('LastArea', null);
    },

    ShowArea: function(id) {
        OfficeWebUI.Workspace.HideAllAreas();
        //var areabutton = $("#" + id);
        //var tempid = areabutton.attr("AssociatedArea");
        //var buttonid = areabutton.attr("id");
        $("div[AssociatedArea=" + id + "]").show();
        $("div[areaid=" + id + "]").addClass("WorkspaceAreaActive");
    },

    Init: function() {
        OfficeWebUI.Workspace.HideAllAreas();
        var tempid = $(".OfficeWebUI_WorkspaceAreaButton:first").attr("AssociatedArea");
        $(".OfficeWebUI_WorkspaceAreaButton:first").addClass("WorkspaceAreaActive");
        $("div[AssociatedArea=" + tempid + "]").show();

        if (OfficeWebUI.Workspace.GetLastItem() != null)
            $("div[WorkspaceInternalid=" + OfficeWebUI.Workspace.GetLastItem() + "]").addClass("OfficeWebUI_WorkspaceItemActive");

        if (OfficeWebUI.Workspace.GetLastArea() != "") {
            OfficeWebUI.Workspace.ShowArea(OfficeWebUI.Workspace.GetLastArea());
        }

        $(".RibbonTabsContainer").bind("Toggled", function() { OfficeWebUI.Workspace.ResizeLayout(); });
    },

    getWindowHeight: function() {
        var windowHeight = 0;
        if (typeof (window.innerHeight) == 'number') {
            windowHeight = window.innerHeight;
        }
        else {
            if (document.documentElement && document.documentElement.clientHeight) {
                windowHeight = document.documentElement.clientHeight;
            }
            else {
                if (document.body && document.body.clientHeight) {
                    windowHeight = document.body.clientHeight;
                }
            }
        }
        return windowHeight;
    },

    ResizeLayoutEvent: function (panelContentHeight, ContainerHeight) {},

    ResizeLayout: function() {

        var windowHeight = OfficeWebUI.Workspace.getWindowHeight();

        var _WorkspaceOffset = $(".OfficeWebUI_Workspace").offset();
        var _WorkspaceTop = _WorkspaceOffset.top;
        var _StatusBarHeight = $(".OfficeWebUI_WorkspaceStatusBar").height();
        if (_StatusBarHeight == null)
          _StatusBarHeight = 0;

        //var _leftPanelHeight = (windowHeight - _WorkspaceTop - 18 - _StatusBarHeight);
        var PanelHeight = (windowHeight - _WorkspaceTop - _StatusBarHeight);

        //PanelHeight = $('.OfficeWebUI_WorkspaceContentPanel').height();

        //$(".OfficeWebUI_WorkspaceLeftPanel").css("height", _leftPanelHeight + "px");
        //$(".OfficeWebUI_Workspace").css("height", _leftPanelHeight + "px");
        //var _AreasOffset = $(".OfficeWebUI_WorkspaceAreaContainer").height();
        
        // Content Panel body ykseklik...
        var panelHeight = PanelHeight;
        var panelHeaderHeight = $(".OfficeWebUI_WorkspaceContentPanelHeader").height();
        var panelHeaderCommandHeight = $(".OfficeWebUI_WorkspaceContentPanelCommandHeader").height();
        var panelContentHeight = panelHeight - (panelHeaderHeight + panelHeaderCommandHeight);
        //$(".OfficeWebUI_WorkspaceContentPanelContent").css("height", panelContentHeight + "px");
        //$("#renderBody").css("height", panelContentHeight + "px");
        //$("#renderBody").css("height", "100%");

        // Gerek ykseklik hesaplanyor yeniden...
        //var heightReal = panelContentHeight + panelHeaderHeight + panelHeaderCommandHeight + 18; // 18px fark var...
        //$(".OfficeWebUI_WorkspaceContentPanel").css("height", heightReal + "px");

        //$(".OfficeWebUI_WorkspaceNavContainer").css("height", (_leftPanelHeight - _AreasOffset + 5) + "px");

        OfficeWebUI.Workspace.ResizeLayoutEvent(PanelHeight, panelContentHeight);
    }

};


//$(document).ready(function() {

//    OfficeWebUI.Workspace.ResizeLayout();

//    $(".OfficeWebUI_Workspace").resize(function() {
//        OfficeWebUI.Workspace.ResizeLayout();
//    });

//    $(window).resize(function() {
//        OfficeWebUI.Workspace.ResizeLayout();
//    });

//    $(".OfficeWebUI_WorkspaceItem").click(function() {
//        OfficeWebUI.Workspace.ClearAllItems();
//        var tempid = $(this).attr("id");
//        $(this).addClass("OfficeWebUI_WorkspaceItemActive");
//        // save last item is in code-behind
//    });

//    OfficeWebUI.Workspace.RegisterAreaButtonClick();
//    OfficeWebUI.Workspace.Init();

//});



/* Button */


$(document).ready(function() {


    $(".ButtonWithMenu").click(function() {
        OfficeWebUI.Button.CloseAllMenus();
        $(this).addClass("ButtonMenuActive");
        $(this).find(".ButtonDropDownMenu").show();
    });


    // Click anywhere on the page
    $(document).bind('click', function(e) {
        var $clicked = $(e.target);

        if (!$clicked.parents().hasClass("ButtonWithMenu")) {
            OfficeWebUI.Button.CloseAllMenus();
        }

    });
    
    
});

OfficeWebUI.Button = {

    CloseAllMenus: function() {
        $(".ButtonWithMenu").removeClass("ButtonMenuActive");
        $(".ButtonDropDownMenu").hide();
    },

};


/* ComboBox */


$(document).ready(function() {
    OfficeWebUI.Combobox.Init();
});

OfficeWebUI.Combobox = {

    Init: function() {

        $(".OfficeWebUI_Combobox_Item").click(function() {
            var _text = $(this).attr("InternalText");
            var _value = $(this).attr("InternalValue");

            var _objRoot = $(this).parents(".OfficeWebUI_Combobox")
            var _objSel = _objRoot.find(".OfficeWebUI_Combobox_Selected");
            _objSel.html(_text);
            _objSel.attr("value", _value);



            var _selTextID = _objRoot.attr("Internal_SelectedTextID");
            var _selValueID = _objRoot.attr("Internal_SelectedValueID");


            document.getElementById(_selTextID).value = _text;
            document.getElementById(_selValueID).value = _value;


            $(this).parent().hide();
            $(".OfficeWebUI_ComboboxActive").removeClass("OfficeWebUI_ComboboxActive");
        });


        $(".OfficeWebUI_Combobox_Selected").click(function() {
            $(this).parent().find(".OfficeWebUI_Combobox_DropDown").toggle();
            $(this).parent().toggleClass("OfficeWebUI_ComboboxActive");
        });


        // Click anywhere on the page
        $(document).bind('click', function(e) {
            var $clicked = $(e.target);

            if (!$clicked.parents().hasClass("OfficeWebUI_Combobox")) {
                $(".OfficeWebUI_Combobox_DropDown").hide();
                $(".OfficeWebUI_ComboboxActive").removeClass("OfficeWebUI_ComboboxActive");
            }

        });
    },

};



/* MessageBox */


$(document).ready(function() {
  OfficeWebUI.MessageBox.InitPopup();    
});

OfficeWebUI.MessageBox = {

    InitPopup: function() {

        var windowWidth = document.body.offsetWidth; //document.documentElement.clientWidth;
        var windowHeight = document.documentElement.clientHeight;

        var _height = $(".OfficeWebUI_Popup").height();
        var _width = $(".OfficeWebUI_Popup").width();

        //alert(_height);
        //alert(windowWidth);

        $(".OfficeWebUI_Popup").css({
            "top": windowHeight / 2 - _height / 2 - 40,
            "left": windowWidth / 2 - _width / 2
        });
    },

    Open: function(title, src, width, height) {

        var windowWidth = document.body.offsetWidth; //document.documentElement.clientWidth;
        var windowHeight = document.documentElement.clientHeight;

        $(".OfficeWebUI_PopupShadow").show();

        $(".PopupTitleSpan").html(title);
        $(".OfficeWebUI_PopupFrame").attr("src", src);

        $(".OfficeWebUI_Popup").css({
            "position": "absolute",
            "top": windowHeight / 2 - height / 2 - 40,
            "left": windowWidth / 2 - width / 2
        });

        $(".OfficeWebUI_PopupTitle").css({
            "width": width
        });

        $(".OfficeWebUI_PopupContentContainer").css({
            "height": height,
            "width": width
        });

        $(".OfficeWebUI_Popup").show();

    },

    Close: function() {
        $(".OfficeWebUI_PopupFrame").attr("src", "about:blank");
        $(".OfficeWebUI_PopupShadow").hide();
        $(".OfficeWebUI_Popup").hide();
    },

};



/* Popup */


$(document).ready(function() {
	OfficeWebUI.Popup.InitPopup();    
});


OfficeWebUI.Popup = {

    InitPopup: function() {

        var windowWidth = document.body.offsetWidth; //document.documentElement.clientWidth;
        var windowHeight = document.documentElement.clientHeight;

        var _height = $(".OfficeWebUI_Popup").height();
        var _width = $(".OfficeWebUI_Popup").width();

        //alert(_height);
        //alert(windowWidth);

        $(".OfficeWebUI_Popup").css({
        "top": windowHeight / 2 - _height / 2 - 40,
        "left": windowWidth / 2 - _width / 2
        });

    },

    Open: function(title, src, width, height) {

        var windowWidth = document.body.offsetWidth; //document.documentElement.clientWidth;
        var windowHeight = document.documentElement.clientHeight;

        $(".OfficeWebUI_PopupShadow").show();

        $(".PopupTitleSpan").html(title);
        $(".OfficeWebUI_PopupFrame").attr("src", src);

        $(".OfficeWebUI_Popup").css({
            "position": "absolute",
            "top": windowHeight / 2 - height / 2 - 40,
            "left": windowWidth / 2 - width / 2
        });

        $(".OfficeWebUI_PopupTitle").css({
            "width": width
        });

        $(".OfficeWebUI_PopupContentContainer").css({
            "height": height,
            "width": width
        });

        $(".OfficeWebUI_Popup").show();

    },

    Close: function() {
        $(".OfficeWebUI_PopupFrame").attr("src", "about:blank");
        $(".OfficeWebUI_PopupShadow").hide();
        $(".OfficeWebUI_Popup").hide();
    },
};

